/*
    FreeDiskO - Mac OSX widget that displays current disk usage.
    Copyright (C) 2009  Steve Dickinson  dsdickinson@mac.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see COPYING file).  If not, see <http://www.gnu.org/licenses/>.
*/

var curr_front = 1;
var curr_back = 0;

// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    curr_front = 0;
	curr_back = 1;
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	
	document.getElementById("units").focus();
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    curr_front = 1;
	curr_back = 0;
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function rundf(event)
{
	var units = document.getElementById('units').value;
    var mntpt = document.getElementById('mntpt').value;
	
	if (! mntpt) {
        var command = "/bin/df -" + units;
	} else {
		// Get the header information in our output
		var header = "/bin/df -" + units + " | grep -v %";	
		var command = "/bin/df -" + units + " | grep % | grep '" + mntpt + "'";
		command = header + "\n" + command;
	}
		
    var obj = widget.system(command, null);
	var output = obj.outputString;
	
	var split_output = output.split("\n");
	if (split_output[1] == "") {
			output = output + "No matches found.";
	}
	
    document.getElementById('output').value = output;
}

function myformat(text, use_length) {
    var length = text.length;
	
	for (var i=length; i<use_length; i++) {
	    text = text + " ";
	}
	
	return (text);
}

 function keyHandler(e)
 {
     var pressedKey;  
     if (window.event) pressedKey = window.event.keyCode;  
     else if (e) pressedKey = e.which;  
     var e = e || window.event;  
	 
	 // CTRL + c
     if (pressedKey == 67 && e.ctrlKey){  
		clearFilter();
	 }
	 
	 // RETURN	 	 
 	 if (pressedKey == 13) {
	     rundf();
	 } 	 
	 
	 // CTRL + i
     if (pressedKey == 73 && e.ctrlKey){  
	     if (curr_front == 1) {
		     showBack();	    
	     } else if (curr_back == 1) {
		     showFront();	    
	     }	 
     }  
 }
document.onkeydown = keyHandler;

function showCodeUni(event)
{
    widget.openURL("http://www.codeuniversity.com");
}

function selectCodeUni(event) 
{
	document.getElementById('text2').style.cursor = "pointer";
}

function clearFilter(event)
{
	document.getElementById('mntpt').value = "";
}